import numpy as np
import matplotlib.pyplot as plt
from sklearn.linear_model import LogisticRegression
from sklearn.svm import LinearSVC,SVC
from sklearn.preprocessing import StandardScaler
import seaborn as sns
sns.set(style="white")


np.random.seed(22)#32,49

x1 = np.random.multivariate_normal([8,6],[[3,1],[1,4]],30)
x2 = np.random.multivariate_normal([0,0],[[2,1],[1,2]],30)



y = np.append(np.ones(30), np.zeros(30))
#y = y.reshape(-1,1)

X = np.vstack((x1,x2))
scaler = StandardScaler()
scaler.fit(X)
X=scaler.transform(X)
x1 = scaler.transform(x1)
x2 = scaler.transform(x2)


plt.scatter(x1[:,0],x1[:,1])
plt.scatter(x2[:,0],x2[:,1])

lr = LogisticRegression(C=1e2)
lr.fit(X,y)
sv = SVC(kernel='linear',shrinking=False  ,C=1e2)
#sv = LinearSVC(penalty='l2',C=1e2,loss='hinge')
sv.fit(X,y)


xx, yy = np.mgrid[-2:2:.01, -2:2:.01]
grid = np.c_[xx.ravel(), yy.ravel()]
probs = lr.decision_function(grid).reshape(xx.shape)
CS=plt.contour(xx, yy, probs, levels=[.0], colors='r', vmin=0, vmax=.6)
plt.clabel(CS, CS.levels, inline=True, fmt='LR', fontsize=10)

probs2 = sv.decision_function(grid).reshape(xx.shape)
CS=plt.contour(xx, yy, probs2, levels=[-1, .0, 1], colors='b', linestyles=['--','-','--'], vmin=0, vmax=.6)
plt.clabel(CS, CS.levels, inline=True, fmt='SVM', fontsize=10)


print(sv.support_vectors_)
svv = sv.support_vectors_
plt.scatter(svv[:,0],svv[:,1])
plt.show()



